<script lang="ts">
  import Button from '$lib/components/Button.svelte';
  import TextField from '$lib/components/fields/TextField.svelte';
  import SelectField from '$lib/components/fields/SelectField.svelte';
  import EmailField from '$lib/components/fields/EmailField.svelte';
  import { axiosInstance } from '$lib/config/index.js';

  export let journal: any = null;

  let id: number,
    name: string,
    href: string;

  if (journal) {
    id = journal.id;
    name = journal.name;
    href = journal.href;
  }

  async function handleSubmit() {
    if (name && href) {
      try {
        const res = await axiosInstance[id ? 'patch' : 'post'](`/journal${id ? `/${id}` : ''}`, {
          name,
          href
        });

        if (res.status === 201) {
          window.location.href = '/admin/journals';
        }

        if (res.status === 200) {
          alert('Успешно сохранено.');
        }
      } catch (err: any) {
        console.error(err);
        switch (err.response.status) {
          case 400:
            alert('Неверные данные');
            break;
          default:
            alert('Возникла ошибка. Попробуйте повторить действие.');
        }
      }
    }
  }
</script>

<form
    method="post"
    on:submit|preventDefault={handleSubmit}
    class="{$$props.class} space-y-6 mx-auto max-w-screen-xl"
>
    <h1 class="text-6xl text-center mb-2 font-serif">
        {#if journal}
            Изменение записи
            <p class="text-lg text-neutral-600"><span class="select-none">ID:</span>{id}</p>
        {:else}
            Создание записи
        {/if}
    </h1>

    <TextField label="Наименование" name="name" bind:value={name}/>
    <TextField label="Ссылка" name="href" bind:value={href}/>

    <section class="flex justify-center gap-6">
        <a href="/admin/journals">
            <Button transparent>Отменить</Button>
        </a>
        <Button>
            {#if journal}
                Изменить
            {:else}
                Создать
            {/if}
        </Button>
    </section>
</form>